Subject: [Gen-art] Gen-ART Telechat review of draft-ietf-dhc-dhcpv6-unknown-msg-06.txt

From: Suresh Krishnan <[email-masked]>
Date: Tue, 25 Mar 2014 18:20:56 -0400

I have been selected as the General Area Review Team (Gen-ART) reviewer
for this draft (for background on Gen-ART, please see
http://www.alvestrand.no/ietf/gen/art/gen-art-FAQ.html).

Please wait for direction from your document shepherd or AD before
posting a new version of the draft.

Document: draft-ietf-dhc-dhcpv6-unknown-msg-06.txt
Reviewer: Suresh Krishnan
Review Date: 2014/03/25
IESG Telechat date: 2014/03/27

Summary: This draft is almost ready for publication as a Proposed 
Standard but I do have a few comments that the authors may wish to consider.

* Section 4.1 (b)

The following text is unclear.

"if the relay agent receives the message for which it is not the target 
according to the message type."

The text that follows talks about new server-to-relay messages sent to 
the relay agent being forwarded back to the server. Such a message will 
not meet either of the conditions laid out in Section 4.1.

The following text seems extraneous

"  However, this is not strictly necessary, since DHCP does not provide
    a signaling message for rejecting unexpected message types, and
    therefore DHCP servers are not expected to respond to such messages."

What exactly is "this" referring to? The DHCP server is not responding 
anyway to such messages.

* Section 4.2

The prescribed behavior here is contradicts the text in section 4.1 
defining a valid message. Specifically, what happens when a relay 
receives an unknown message type for which it is the intended target. 
According to 4.1, the relay does nothing. According to 4.2 the relay 
forwards.

Thanks
Suresh

---

From: Ted Lemon <[email-masked]>
Date: Tue, 25 Mar 2014 17:46:26 -0500

On Mar 25, 2014, at 5:20 PM, Suresh Krishnan <[email-masked]> wrote:
> "if the relay agent receives the message for which it is not the target according to the message type."
> 
> The text that follows talks about new server-to-relay messages sent to the relay agent being forwarded back to the server. Such a message will not meet either of the conditions laid out in Section 4.1.

It might be better to make point (b) this way:

     (b) if the relay agent receives the message for which it does
         not identify itself as the target.

  At present the only DHCP message that could be intended for a relay
  agent would be a LEASEQUERY-REPLY message [RFC5007].   Such messages
  are only correctly generated in response to LEASEQUERY messages sent
  by a relay agent acting as a leasequery requestor.   It is therefore
  expected that such messages will be able to be identified by relay
  agents.

The text that follows is intended to address the case where a new message type is defined that is intended to be sent, unsolicited, to a relay agent.   It might be made clearer as follows:

   New DHCP message types may be defined in future that are sent,
   unsolicited, to relay agents.  Relay agents
   that do not implement these messages will not recognize such
   messages as being intended for them.  A relay agent that implements this
   specification will therefore forward such messages to the DHCP
   servers to which it is configured to relay client messages.

   At this time, no such message types have been specified.  If
   such a message is specified in the future, it is possible that this
   would result in needless load on DHCP servers.   If such a message
   type is defined in a future specification, authors may need to
   consider some strategy for identifying non-conforming relays and
   not sending such messages to them.

   However, since DHCP servers do not respond to unknown messages,
   this is unlikely to create significant load, and therefore is
   likely to be unnecessary. 

> What exactly is "this" referring to? The DHCP server is not responding anyway to such messages.

The reason for not just deleting this text is that it _is_ possible to define an unsolicited relay message in such a way that it could cause problems, so the author really does need to think about it, and it's reasonably likely that they will read this advice before doing so, or at least that someone who reviews the document will be aware of this advice.

> * Section 4.2
> 
> The prescribed behavior here is contradicts the text in section 4.1 defining a valid message. Specifically, what happens when a relay receives an unknown message type for which it is the intended target. According to 4.1, the relay does nothing. According to 4.2 the relay forwards.

No, according to 4.1 it forwards as well, unless it's the intended recipient of the message.   And it can only tell that it's the intended recipient if it understands that type of message.   So the two sections do not contradict each other.   Hopefully this is more clear with the new text.   Stephen Farrell raised some related questions; updating the text as I've suggested should address his concerns as well.

---

From: Jari Arkko <[email-masked]>
Date: Wed, 26 Mar 2014 14:31:14 +0800

Thanks for the review and suggested changes. Suresh, would you be OK with Ted's proposed change?

We need to resolve this before the document can be approved, I think.

Jari

On Mar 26, 2014, at 6:46 AM, Ted Lemon <[email-masked]> wrote:

> _______________________________________________
> Gen-art mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/gen-art

---

From: Brian Haberman <[email-masked]>
Date: Wed, 26 Mar 2014 08:01:39 -0400

Jari,

> We need to resolve this before the document can be approved, I think.

As shepherding AD, I agree this should be resolved prior to approval.

Regards,
Brian

---

From: Suresh Krishnan <[email-masked]>
Date: Thu, 27 Mar 2014 13:25:56 +0000

Hi all,
  Ted's proposed text changes clarify things a lot (Thanks!), but 4.1 b) was still a bit unclear. Ted, Qi and I had some offline discussions and realized that this was because there were three different classes of messages that the relay agent handles, that it needs to forward to the server.

1) Relay forwards from other relays
2) Messages that the relay knows about but is not the intended target of (e.g. known Client messages)
3) Unknown messages

With this in mind, I would like to propose the following drafty text for section 4.1.
 
The message is valid for constructing a new Relay-forward message:

(a) if the message is a Relay-forward message, or
(b) if the relay agent recognizes the message type and is not the intended target, or
(c) if the relay agent does not recognize the message type

Let me know what you think.

Cheers
Suresh

> -----Original Message-----
> From: Ted Lemon [mailto:[email-masked]]
> Sent: March-25-14 6:46 PM
> To: Suresh Krishnan
> Cc: [email-masked]; General Area
> Review Team
> Subject: Re: Gen-ART Telechat review of draft-ietf-dhc-dhcpv6-unknown-msg-
> 06.txt
> 
> The text that follows is intended to address the case where a new message
> type is defined that is intended to be sent, unsolicited, to a relay
> agent.   It might be made clearer as follows:
> 
> The reason for not just deleting this text is that it _is_ possible to
> define an unsolicited relay message in such a way that it could cause
> problems, so the author really does need to think about it, and it's
> reasonably likely that they will read this advice before doing so, or at
> least that someone who reviews the document will be aware of this advice.
> 
> 
> > * Section 4.2
> >
> defining a valid message. Specifically, what happens when a relay receives
> an unknown message type for which it is the intended target. According to
> 4.1, the relay does nothing. According to 4.2 the relay forwards.
> 
> No, according to 4.1 it forwards as well, unless it's the intended
> recipient of the message.   And it can only tell that it's the intended
> recipient if it understands that type of message.   So the two sections do
> not contradict each other.   Hopefully this is more clear with the new
> text.   Stephen Farrell raised some related questions; updating the text
> as I've suggested should address his concerns as well.

---

From: Ted Lemon <[email-masked]>
Date: Thu, 27 Mar 2014 08:28:00 -0500

> Let me know what you think.

I think this covers all cases.